routes/web.php
<?php

use App\Http\Controllers\AlbumController;
use App\Http\Controllers\ArtistController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\CustomerController;
use App\Http\Controllers\EmployeeController;
use App\Http\Controllers\IndexController;
use App\Http\Controllers\InvoiceController;
use App\Http\Controllers\PlaylistController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\TrackController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/* Index : show all * Show : show one * Create : show form to create * Store : store new * Edit : show form to edit * Update : update * Destroy : delete */
Route::get('/', [IndexController::class, 'index'])->name('index');

Route::get('/register', [UserController::class, 'create'])->name('register');
Route::get('/login', [UserController::class, 'login'])->name('login');
Route::get('/logout', [UserController::class, 'logout'])->name('logout');

Route::name('users.')->group(function () {
    Route::post('/users/authenticate', [UserController::class, 'authenticate'])->name('authenticate');
    Route::post('/users', [UserController::class, 'store'])->name('store');
    Route::get('/account', [UserController::class, 'accountIndex'])->name('account');
    Route::patch('/users/{user}', [UserController::class, 'update'])->name('update');
});

Route::name('albums.')->group(function () {
    Route::get('/albums', [AlbumController::class, 'index'])->name('index');
    Route::get('/albums/create', [AlbumController::class, 'create'])->name('create');
    Route::post('/albums', [AlbumController::class, 'store'])->name('store');
    Route::get('/albums/export/', [AlbumController::class, 'export'])->name('export');
    Route::post('/albums/{album}/cart', [AlbumController::class, 'addToCart'])->name('cart');
    Route::get('/albums/{album}/export', [AlbumController::class, 'exportOne'])->name('export.one');
    Route::get('/albums/{album}/edit', [AlbumController::class, 'edit'])->name('edit');
    Route::post('/albums/{album}/restore', [AlbumController::class, 'restore'])->name('restore');
    Route::delete('/albums/{album}', [AlbumController::class, 'destroy'])->name('destroy');
    Route::put('/albums/{album}', [AlbumController::class, 'update'])->name('update');
    Route::get('/albums/{album}', [AlbumController::class, 'show'])->name('show');
});

Route::name('tracks.')->group(function () {
    Route::get('/tracks', [TrackController::class, 'index'])->name('index');
    Route::get('/tracks/create', [TrackController::class, 'create'])->name('create');
    Route::get('/tracks/{track}', [TrackController::class, 'edit'])->name('edit');
    Route::put('/tracks/{track}', [TrackController::class, 'update'])->name('update');
    Route::post('/tracks', [TrackController::class, 'store'])->name('store');
    Route::delete('/tracks/{track}', [TrackController::class, 'destroy'])->name('destroy');
    Route::post('/tracks/{track}/restore', [TrackController::class, 'restore'])->name('restore');
});

Route::name('artists.')->group(function () {
    Route::get('/artists', [ArtistController::class, 'index'])->name('index');
    Route::get('/artists/export', [ArtistController::class, 'export'])->name('export');
    Route::get('/artists/create', [ArtistController::class, 'create'])->name('create');
    Route::delete('/artists/{artist}', [ArtistController::class, 'destroy'])->name('destroy');
    Route::get('/artists/{artist}/edit', [ArtistController::class, 'edit'])->name('edit');
    Route::post('/artists/{artist}/restore', [ArtistController::class, 'restore'])->name('restore');
    Route::put('/artists/{artist}', [ArtistController::class, 'update'])->name('update');
    Route::post('/artists', [ArtistController::class, 'store'])->name('store');
});

Route::name('playlists.')->group(function () {
    Route::get('/playlists', [PlayListController::class, 'index'])->name('index');
    Route::get('/playlists/{playlist}/export', [PlaylistController::class, 'export'])->name('export');
    Route::get('/playlists/create', [PlaylistController::class, 'create'])->name('create');
    Route::get('/playlists/{playlist}', [PlayListController::class, 'show'])->name('show');
    Route::get('/playlists/{playlist}/create', [PlaylistController::class, 'createTrack'])->name('tracks.create');
    Route::post('/playlists/{playlist}', [PlayListController::class, 'storeTrack'])->name('tracks.store');
    Route::delete('/playlists/{playlist}', [PlaylistController::class, 'destroy'])->name('destroy');
    Route::delete('/playlists/{playlist}/{track}', [PlayListController::class, 'destroyTrack'])->name('destroy.track');
    Route::post('/playlists', [PlayListController::class, 'store'])->name('store');
});

Route::name('invoices.')->group(function () {
    Route::get('/invoices', [InvoiceController::class, 'index'])->name('index');
    Route::delete('/invoices/{invoice}', [InvoiceController::class, 'destroy'])->name('destroy');
    Route::get('/invoices/{invoice}', [InvoiceController::class, 'show'])->name('show');
});

Route::name('cart.')->group(function () {
    Route::get('/cart', [CartController::class, 'index'])->name('index');
    Route::get('/cart/success', [CartController::class, 'success'])->name('success');
    Route::post('/cart', [CartController::class, 'store'])->name('store');
    Route::post('/cart/create-step-one', [CartController::class, 'createStepOneStore'])->name('create.step.one.store');
    Route::post('/cart/{track}', [CartController::class, 'addToCart'])->name('add');
    Route::delete('/cart/{id}', [CartController::class, 'deleteFromCart'])->name('delete');
    // we could use PUT if route --> /cart/{id}/quantity
    Route::patch('/cart/{id}', [CartController::class, 'update'])->name('update');
});

Route::name('customers.')->group(function () {
    Route::get('/customers', [CustomerController::class, 'index'])->name('index');
    Route::get('/customers/create', [CustomerController::class, 'create'])->name('create');
    Route::delete('/customers/{customer}', [CustomerController::class, 'destroy'])->name('destroy');
    Route::post('/customers', [CustomerController::class, 'store'])->name('store');
    Route::get('/customers/{customer}/edit', [CustomerController::class, 'edit'])->name('edit');
    Route::post('/customers/{customer}/restore', [CustomerController::class, 'restore'])->name('restore');
    Route::put('/customers/{customer}', [CustomerController::class, 'update'])->name('update');
});

Route::name('employees.')->group(function () {
    Route::get('/employees', [EmployeeController::class, 'index'])->name('index');
    Route::get('/employees/create', [EmployeeController::class, 'create'])->name('create');
    Route::delete('/employees/{employee}', [EmployeeController::class, 'destroy'])->name('destroy');
    Route::post('/employees', [EmployeeController::class, 'store'])->name('store');
    Route::get('/employees/{employee}/edit', [EmployeeController::class, 'edit'])->name('edit');
    Route::post('/employees/{employee}/restore', [EmployeeController::class, 'restore'])->name('restore');
    Route::put('/employees/{employee}', [EmployeeController::class, 'update'])->name('update');
    Route::post('/employees/{employee}/account', [EmployeeController::class, 'storeAccount'])->name('store.account');
});

Route::name('roles.')->group(function () {
    Route::get('/roles', [RoleController::class, 'index'])->name('index');
    Route::get('/roles/create', [RoleController::class, 'create'])->name('create');
    Route::post('/roles', [RoleController::class, 'store'])->name('store');
    Route::get('/roles/{role}/edit', [RoleController::class, 'edit'])->name('edit');
    Route::put('/roles/{role}', [RoleController::class, 'update'])->name('update');
    Route::delete('/roles/{role}', [RoleController::class, 'destroy'])->name('destroy');
});

Route::fallback(fn () => abort(404));

app/Models/Artist.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Kyslik\ColumnSortable\Sortable;

class Artist extends Model
{
    use HasFactory, SoftDeletes, Sortable;

    protected $sortable = ['name', 'updated_at'];
    protected $sortableAs = ['tracks_count', 'albums_count'];
    protected $fillable = ['pochette', 'name'];
    protected $withCount = ['albums', 'tracks'];

    public function albums() {
        return $this->hasMany(Album::class, 'artist_id');
    }

    public function tracks() {
        return $this->hasManyThrough(Track::class, Album::class);
    }

    public function scopeFilter($query, array $filter) {
        if ($filter['search'] ?? false)
            return $query->where('name', 'like', '%' . $filter['search'] . '%');

        if ($filter['artist'] ?? false)
            return $query->where('id', '=', $filter['artist']);

        return $query;
    }

    public static function boot() {
        parent::boot();
        static::deleting(fn($artist) => $artist->albums()->delete());
        static::restoring(fn($artist) => $artist->albums()->restore());
    }
}

app/Http/Controllers/ArtistController.php
<?php

namespace App\Http\Controllers;

use App\Exports\ArtistsExport;
use App\Models\Artist;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use Maatwebsite\Excel\Facades\Excel;

class ArtistController extends Controller
{
    public function __construct(){
        $this->middleware('auth');
        $this->middleware('permission:artists.edit')->only(['edit', 'update']);
        $this->middleware('permission:artists.delete')->only(['destroy', 'restore']);
        $this->middleware('permission:artists.create')->only(['create', 'store']);
    }

    public function index(){
        $artists = auth()->user()->can('artists.delete') ? Artist::withTrashed() : Artist::withoutTrashed();
        $artists = $artists->sortable()
            ->withCount(['tracks'])
            ->orderBy('updated_at', 'desc')
            ->filter(\request()->input());
        return view('artists.index')->with('artists', $artists->paginate(15));
    }

    public function destroy(Artist $artist){
        $artist->delete();
        return back()->with('success', 'Suppression de l\'artiste avec succès !');
    }

    public function restore($artistId){
        $artist = Artist::onlyTrashed()->findOrFail($artistId);
        $artist->restore();
        return back()->with('success', 'Artiste restauré avec succès.');
    }

    public function edit(Artist $artist){
        return view('artists.edit')->with('artist', $artist);
    }

    public function create(){
        return view('artists.create')->with('artist', new Artist());
    }

    public function update(Request $request, Artist $artist){
        $formFields = [];

        if ($request->input('name') != $artist->name)
            $formFields = $request->validate(['name' => ['required', 'min:2', Rule::unique('artists', 'name')]]);

        if ($request->hasFile('pochette'))
            $formFields['pochette'] = $request->file('pochette')->store('artists', 'public');

        $artist->update($formFields);

        return back()->with('success', 'Modification réussie avec succès !');
    }

    public function store(Request $request){
        $formFields = $request->validate(['name' => ['required', 'min:2', Rule::unique('artists', 'name')]]);

        if ($request->hasFile('pochette'))
            $formFields['pochette'] = $request->file('pochette')->store('artists', 'public');

        Artist::create($formFields);

        return back()->with('success', 'Création réussie avec succès !');
    }

    public function export(){
        return Excel::download(new ArtistsExport, 'artists.xlsx');
    }
}

resources/views/artists/create.blade.php
<x-layout>
    {{ Breadcrumbs::render() }}

    <x-title>
        <x-slot name="pageHeading">
            Création d'un <span class="text-blue-600">artiste</span>
        </x-slot>
        <a href="{{ route('artists.index') }}" class="cursor-pointer w-full px-4 py-2 text-sm text-white font-medium bg-blue-500 hover:bg-blue-600 border border-blue-600 rounded-md shadow-button">
            Retour aux artistes
        </a>
    </x-title>

    <div class="flex max-w-lg mx-auto flex-col mt-10">
        <div class="p-8 bg-white rounded shadow">
            <div class=" text-center">
                <span class="text-sm text-blueGray-400 content-center">Artistes</span>
                <h4 class="mb-6 text-3xl">Créer un artiste</h4>
            </div>
            <form method="POST" action="{{ route('artists.store') }}" role="form" enctype="multipart/form-data">
                @csrf
                @include('artists.form')
            </form>
        </div>
    </div>
</x-layout>

resources/views/artists/edit.blade.php
<x-layout>
    {{ Breadcrumbs::render() }}

    <x-title>
        <x-slot name="pageHeading">
            Modification d'un <span class="text-blue-600">artiste</span>
        </x-slot>
        <a href="{{ route('artists.index') }}" class="cursor-pointer w-full px-4 py-2 text-sm text-white font-medium bg-blue-500 hover:bg-blue-600 border border-blue-600 rounded-md shadow-button">
            Retour
        </a>
    </x-title>

    <div class="flex max-w-lg mx-auto flex-col mt-10">
        <div class="p-8 bg-white rounded shadow">
            <div class=" text-center">
                <span class="text-sm text-blueGray-400 content-center">Artistes</span>
                <h4 class="mb-6 text-3xl">Modifier un artiste</h4>
            </div>
            <form method="POST" action="{{ route('artists.update', $artist) }}" role="form" enctype="multipart/form-data">
                @method('PUT')
                @csrf
                @include('artists.form')
            </form>
        </div>
    </div>
</x-layout>

resources/views/artists/form.blade.php
<!--{{ old('username') }}-->

<input value="{{$artist->name}}" class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none @error('name') border-2 border-red-500 @enderror" type="text" name="name" placeholder="Nom de l'artiste" required>
@error('name')<p class="text-red-500 text-xs italic">{{$message}}</p>@enderror

<span class="font-medium block mt-4">Pochette:</span>
<input class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none" type="file" name="pochette">

<button class="mt-4 block w-full p-4 text-center text-xs text-white font-semibold leading-none bg-blue-600 hover:bg-blue-700 rounded">Valider les informations</button>

resources/views/artists/index.blade.php
<x-layout>
    {{ Breadcrumbs::render() }}

    <x-search title="des artistes" searchBy="Cherchez par les noms d'artistes." />

    <x-title>
        <x-slot name="pageHeading">
            Liste des <span class="text-blue-600">artistes</span>
        </x-slot>
        <a href="{{ route('artists.export') }}" class="cursor-pointer px-4 py-2 text-sm text-white font-medium bg-blue-500 hover:bg-blue-600 border border-blue-600 rounded-md shadow-button">
            Exporter <i class="ml-2 fa fa-file-excel-o" aria-hidden="true"></i>
        </a>
        @can('artists.create')
            <a href="{{route('artists.create')}}" class="ml-2 cursor-pointer w-full px-4 py-2 text-sm text-white font-medium bg-green-500 hover:bg-green-600 border border-green-600 rounded-md shadow-button">
                Ajouter un artiste
            </a>
        @endcan
    </x-title>

    <div class="relative overflow-x-auto shadow-md sm:rounded-lg mt-10">
        <table class="w-full text-sm text-left text-gray-500">
            <thead class="text-xs text-gray-700 uppercase bg-gray-50">
            <tr>
                <th scope="col" class="px-6 py-3">
                    @sortablelink('name', 'Nom de l\'artiste')
                </th>
                <th scope="col" class="px-6 py-3">
                    @sortablelink('albums_count', 'Nombre d\'albums')
                </th>
                <th scope="col" class="px-6 py-3">
                    @sortablelink('tracks_count', 'Nombre de titres')
                </th>
                <th scope="col" class="px-6 py-3">
                    @sortablelink('updated_at', 'Dernière modification')
                </th>
                <th scope="col" class="px-6 py-3">
                    <span class="sr-only">Actions</span>
                </th>
            </tr>
            </thead>
            <tbody>
            @foreach($artists as $artist)
                <tr class="bg-white border-b">
                    <th scope="row" class="px-6 py-4 font-medium text-gray-900 dark:text-white whitespace-nowrap flex items-center">
                        <img alt="pochette" class="w-12 rounded-full hidden lg:flex" src="{{$artist->pochette ? asset('/storage/'.$artist->pochette) : asset('/images/no-image.png')}}">
                        <div class="pl-4">
                            <p class="font-semibold">{{$artist->name}}</p>
                        </div>
                    </th>
                    <td class="px-6 py-4">
                        {{$artist->albums_count}}
                    </td>
                    <td class="px-6 py-4">
                        {{$artist->tracks_count}}
                    </td>
                    <td class="px-6 py-4">
                        {{$artist->updated_at}}
                    </td>
                    <td class="px-6 py-4">
                        <div class="flex justify-end">
                            @unless($artist->trashed())
                                <a class="border hover:bg-gray-50 font-semibold py-1 px-2 rounded" href="{{route('albums.index', ['artist' => $artist->id])}}">🔎</a>

                                @can('artists.edit')
                                    <a class="border ml-1 hover:bg-gray-50 font-semibold py-1 px-2 rounded" href="{{route('artists.edit', $artist->id)}}">✏</a>
                                @endcan

                                @can('artists.delete')
                                    <form action="{{route('artists.destroy', $artist->id)}}" method="POST">
                                        @csrf @method('DELETE')
                                        <button type="submit" class="border hover:bg-gray-50 font-semibold py-1 px-2 rounded ml-1">❌</button>
                                    </form>
                                @endcan
                            @else
                                <form action="{{ route('artists.restore', $artist->id) }}" method="POST">
                                    @csrf
                                    <button type="submit" class="border hover:bg-gray-50 font-semibold py-1 px-2 rounded">🔓</button>
                                </form>
                            @endunless
                        </div>
                    </td>
                </tr>
            @endforeach
            </tbody>
        </table>
    </div>

    @if($artists->hasPages())
        <div class="mt-10">
            {!! $artists->appends(\Request::except('page'))->render() !!}
        </div>
    @endif
</x-layout>